#ifndef BLOCK_DATA_H
#define BLOCK_DATA_H

#include <cstdint>

#include "textureatlas.h"

#define BLOCK_SIZE 120

typedef uint8_t BLOCK;

extern const char *block_names[];
extern COLOR block_colors[];
extern TextureAtlasEntry *block_textures;

void init_blockData(TEXTURE *texture);
void uninit_blockData();

#ifndef TEXTURE_SUPPORT
    #define LIGHTING
#endif

#define BLOCK_AIR 0
#define BLOCK_STONE 1
#define BLOCK_DIRT 2
#define BLOCK_SAND 3
#define BLOCK_WOOD 4
#define BLOCK_LEAVES 5
#define BLOCK_PLANKS 6
#define BLOCK_WALL 7
#define BLOCK_COAL_ORE 8
#define BLOCK_MAX 9

#endif // BLOCK_DATA_H
